## rtmidi 4.0.0

=== CMakeLists.txt ===
# 2018 (c) Juan G. Victores, Bartek Łukawski, Stephen Sinclair
# CopyPolicy: RtMidi license.

# Set minimum CMake required version for this project.
cmake_minimum_required(VERSION 3.10 FATAL_ERROR)

# Define a C++ project.
project(RtMidi LANGUAGES CXX)

# Check for Jack (any OS)
find_library(JACK_LIB jack)
find_package(PkgConfig)
pkg_check_modules(jack jack)
if(JACK_LIB OR jack_FOUND)
  set(HAVE_JACK TRUE)
endif()

# Necessary for Windows
if(WIN32)
  set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
endif()

# Standard CMake options
option(BUILD_SHARED_LIBS "Build as shared library" ON)

if (NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug;Release;RelWithDebInfo;MinSizeRel")
endif()
if(WINDOWS)
  set(CMAKE_DEBUG_POSTFIX d CACHE STRING "Postfix for debug version of library")
endif()

# Build Options
set(RTMIDI_TARGETNAME_UNINSTALL "uninstall" CACHE STRING "Name of 'uninstall' build target")

# API Options
option(RTMIDI_API_JACK "Compile with JACK support." ${HAVE_JACK})
if(UNIX AND NOT APPLE)
  option(RTMIDI_API_ALSA "Compile with ALSA support." ON)
endif()
option(RTMIDI_API_WINMM "Compile with WINMM support." ${WIN32})
option(RTMIDI_API_CORE "Compile with CoreMIDI support." ${APPLE})

# Add -Wall if possible
if (CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
endif (CMAKE_COMPILER_IS_GNUCXX)

# Add debug flags
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  add_definitions(-D__RTMIDI_DEBUG__)
  if (CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
  endif (CMAKE_COMPILER_IS_GNUCXX)
endif ()

# Read libtool version info from configure.ac
set(R "m4_define\\(\\[lt_([a-z]+)\\], ([0-9]+)\\)")
file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/configure.ac" CONFIGAC
  REGEX ${R})
foreach(_S ${CONFIGAC})
  string(REGEX REPLACE ${R} "\\1" k ${_S})
  string(REGEX REPLACE ${R} "\\2" v ${_S})
  set(SO_${k} ${v})
endforeach()
math(EXPR SO_current_minus_age "${SO_current} - ${SO_age}")
set(SO_VER "${SO_current_minus_age}")
set(FULL_VER "${SO_current_minus_age}.${SO_revision}.${SO_age}")

# Read package version info from configure.ac
set(R "AC_INIT\\(RtMidi, ([0-9\\.]+),.*\\)")
file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/configure.ac" CONFIGAC
  REGEX ${R})
string(REGEX REPLACE ${R} "\\1" PACKAGE_VERSION ${CONFIGAC})

# Init variables
set(rtmidi_SOURCES RtMidi.cpp RtMidi.h rtmidi_c.cpp rtmidi_c.h)
set(LINKLIBS)
set(INCDIRS)
set(PKGCONFIG_REQUIRES)
set(API_DEFS)
set(API_LIST)

# Tweak API-specific configuration.

# Jack
if(RTMIDI_API_JACK)
  if (NOT HAVE_JACK)
    message(FATAL_ERROR "Jack API requested but no Jack dev libraries found")
  endif()
  set(NEED_PTHREAD ON)
  list(APPEND PKGCONFIG_REQUIRES "jack")
  list(APPEND API_DEFS "-D__UNIX_JACK__")
  list(APPEND API_LIST "jack")
  if(jack_FOUND)
    list(APPEND LINKLIBS ${jack_LIBRARIES})
    list(APPEND INCDIRS ${jack_INCLUDEDIR})
  else()
    list(APPEND LINKLIBS ${JACK_LIB})
  endif()

  # Check for jack_port_rename
  include(CheckSymbolExists)
  set(tmp_CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES})
  list(APPEND CMAKE_REQUIRED_LIBRARIES jack)
  check_symbol_exists(jack_port_rename ${jack_INCLUDEDIR}/jack/jack.h JACK_HAS_PORT_RENAME)
  set(CMAKE_REQUIRED_LIBRARIES ${tmp_CMAKE_REQUIRED_LIBRARIES})
  if(JACK_HAS_PORT_RENAME)
    list(APPEND API_DEFS "JACK_HAS_PORT_RENAME")
  endif()
endif()

# ALSA
if(RTMIDI_API_ALSA)
  set(NEED_PTHREAD ON)
  find_package(ALSA)
  if (NOT ALSA_FOUND)
    message(FATAL_ERROR "ALSA API requested but no ALSA dev libraries found")
  endif()
  list(APPEND INCDIRS ${ALSA_INCLUDE_DIR})
  list(APPEND LINKLIBS ${ALSA_LIBRARY})
  list(APPEND PKGCONFIG_REQUIRES "alsa")
  list(APPEND API_DEFS "-D__LINUX_ALSA__")
  list(APPEND API_LIST "alsa")
endif()

# WinMM
if(RTMIDI_API_WINMM)
  list(APPEND API_DEFS "-D__WINDOWS_MM__")
  list(APPEND API_LIST "winmm")
  list(APPEND LINKLIBS winmm)
endif()

# CoreMIDI
if(RTMIDI_API_CORE)
  list(APPEND API_DEFS "-D__MACOSX_CORE__")
  list(APPEND API_LIST "coremidi")
  list(APPEND LINKLIBS "-framework CoreServices")
  list(APPEND LINKLIBS "-framework CoreAudio")
  list(APPEND LINKLIBS "-framework CoreMIDI")
  list(APPEND LINKLIBS "-framework CoreFoundation")
  list(APPEND LINKFLAGS "-Wl,-F/Library/Frameworks")
endif()

# pthread
if (NEED_PTHREAD)
  find_package(Threads REQUIRED
    CMAKE_THREAD_PREFER_PTHREAD
    THREADS_PREFER_PTHREAD_FLAG)
  list(APPEND LINKLIBS Threads::Threads)
endif()

# Create library targets.
cmake_policy(SET CMP0042 OLD)
set(LIB_TARGETS)

# Use RTMIDI_BUILD_SHARED_LIBS / RTMIDI_BUILD_STATIC_LIBS if they
# are defined, otherwise default to standard BUILD_SHARED_LIBS.
if (DEFINED RTMIDI_BUILD_SHARED_LIBS AND NOT RTMIDI_BUILD_SHARED_LIBS STREQUAL "")
  if (RTMIDI_BUILD_SHARED_LIBS)
    add_library(rtmidi SHARED ${rtmidi_SOURCES})
  else()
    add_library(rtmidi STATIC ${rtmidi_SOURCES})
  endif()
elseif (DEFINED RTMIDI_BUILD_STATIC_LIBS AND NOT RTMIDI_BUILD_STATIC_LIBS STREQUAL "")
  if (RTMIDI_BUILD_STATIC_LIBS)
    add_library(rtmidi STATIC ${rtmidi_SOURCES})
  else()
    add_library(rtmidi SHARED ${rtmidi_SOURCES})
  endif()
else()
  add_library(rtmidi ${rtmidi_SOURCES})
endif()
list(APPEND LIB_TARGETS rtmidi)

# Add headers destination for install rule.
set_target_properties(rtmidi PROPERTIES PUBLIC_HEADER RtMidi.h
  SOVERSION ${SO_VER}
  VERSION ${FULL_VER})

# Set include paths, populate target interface.
target_include_directories(rtmidi PRIVATE
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  ${INCDIRS})

# Set compile-time definitions
target_compile_definitions(rtmidi PRIVATE ${API_DEFS})
target_compile_definitions(rtmidi PRIVATE RTMIDI_EXPORT)
target_link_libraries(rtmidi ${LINKLIBS})

# Set standard installation directories.
include(GNUInstallDirs)

# Add tests if requested.
include(CTest)
if (NOT DEFINED RTMIDI_BUILD_TESTING OR RTMIDI_BUILD_TESTING STREQUAL "")
  set(RTMIDI_BUILD_TESTING ${BUILD_TESTING})
endif()
if (RTMIDI_BUILD_TESTING)
  add_executable(cmidiin    tests/cmidiin.cpp)
  add_executable(midiclock  tests/midiclock.cpp)
  add_executable(midiout    tests/midiout.cpp)
  add_executable(midiprobe  tests/midiprobe.cpp)
  add_executable(qmidiin    tests/qmidiin.cpp)
  add_executable(sysextest  tests/sysextest.cpp)
  add_executable(apinames   tests/apinames.cpp)
  list(GET LIB_TARGETS 0 LIBRTMIDI)
  set_target_properties(cmidiin midiclock midiout midiprobe qmidiin sysextest apinames
    PROPERTIES RUNTIME_OUTPUT_DIRECTORY tests
               INCLUDE_DIRECTORIES ${CMAKE_CURRENT_SOURCE_DIR}
               LINK_LIBRARIES ${LIBRTMIDI})
  add_test(NAME apinames COMMAND apinames)
endif()

# Set standard installation directories.
include(GNUInstallDirs)

# Message
string(REPLACE ";" " " apilist "${API_LIST}")
message(STATUS "Compiling with support for: ${apilist}")

# PkgConfig file
string(REPLACE ";" " " req "${PKGCONFIG_REQUIRES}")
string(REPLACE ";" " " api "${API_DEFS}")
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/rtmidi.pc.in" "rtmidi.pc" @ONLY)

# Add install rule.
install(TARGETS ${LIB_TARGETS}
        EXPORT RtMidiTargets
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

# Store the package in the user registry.
export(PACKAGE RtMidi)

# Set installation path for CMake files.
set(RTMIDI_CMAKE_DESTINATION share/rtmidi)

# Create CMake configuration export file.
if(NEED_PTHREAD)
  file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/RtMidiConfig.cmake "find_package(Threads REQUIRED)\n")
endif()

file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/RtMidiConfig.cmake "include(\${CMAKE_CURRENT_LIST_DIR}/RtMidiTargets.cmake)")

# Install CMake configuration export file.
install(FILES ${CMAKE_BINARY_DIR}/RtMidiConfig.cmake
        DESTINATION ${RTMIDI_CMAKE_DESTINATION})

# Export library target (build-tree).
export(EXPORT RtMidiTargets
       NAMESPACE RtMidi::)

# Export library target (install-tree).
install(EXPORT RtMidiTargets
        DESTINATION ${RTMIDI_CMAKE_DESTINATION}
        NAMESPACE RtMidi::)

# Configure uninstall target.
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/RtMidiConfigUninstall.cmake.in"
    "${CMAKE_BINARY_DIR}/RtMidiConfigUninstall.cmake" @ONLY)

# Create uninstall target.
add_custom_target(${RTMIDI_TARGETNAME_UNINSTALL}
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_BINARY_DIR}/RtMidiConfigUninstall.cmake)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/rtmidi.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

## rtmidi 1.0.15~ds0

=== debian/changelog ===
rtmidi (1.0.15~ds0-2) unstable; urgency=low

  * Build on linux only.
  * Fix wrong linking order.

 -- Alessio Treglia <alessio@debian.org>  Sun, 05 Feb 2012 19:24:57 +0100

rtmidi (1.0.15~ds0-1) unstable; urgency=low

  * Initial release. (Closes: #656191)

 -- Alessio Treglia <alessio@debian.org>  Tue, 17 Jan 2012 09:26:55 +0100

=== debian/control ===
Source: rtmidi
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Alessio Treglia <alessio@debian.org>
Build-Depends:
 debhelper (>= 8.1.3~),
 dh-autoreconf,
 libjack-dev
Standards-Version: 3.9.2
Homepage: http://www.music.mcgill.ca/~gary/rtmidi/
Vcs-Git: git://git.debian.org/pkg-multimedia/rtmidi.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/rtmidi.git

Package: librtmidi1
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: C++ library for realtime MIDI input/ouput
 RtMidi is a set of C++ classes that provides a common API (Application
 Programming Interface) for realtime MIDI input/output across Linux
 (native ALSA, JACK, and OSS), Macintosh OS X, SGI, and Windows
 (DirectSound and ASIO) operating systems. RtMidi significantly
 simplifies the process of interacting with computer audio hardware. It
 was designed with the following objectives:
 .
  * object-oriented C++ design
  * simple, common API across all supported platforms
  * only one source and two header files for easy inclusion in
    programming projects
  * MIDI device enumeration
 .
 MIDI input and output functionality are separated into two classes,
 RtMidiIn and RtMidiOut. Each class instance supports only a single MIDI
 connection. RtMidi does not provide timing functionality (i.e., output
 messages are sent immediately). Input messages are timestamped with delta
 times in seconds (via a double floating point type). MIDI data is passed
 to the user as raw bytes using an std::vector<unsigned char>.
 .
 This package provides the shared library.

Package: librtmidi-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends:
 libjack-dev,
 librtaudio-dev,
 librtmidi1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: C++ library for realtime MIDI input/ouput (development files)
 RtMidi is a set of C++ classes that provides a common API (Application
 Programming Interface) for realtime MIDI input/output across Linux
 (native ALSA, JACK, and OSS), Macintosh OS X, SGI, and Windows
 (DirectSound and ASIO) operating systems. RtMidi significantly
 simplifies the process of interacting with computer audio hardware.
 .
 This package provides the development files.

Package: librtmidi-dbg
Section: debug
Priority: extra
Architecture: linux-any
Multi-Arch: same
Depends:
 librtmidi1 (= ${binary:Version}),
 ${misc:Depends}
Description: C++ library for realtime MIDI input/ouput (debugging symbols)
 RtMidi is a set of C++ classes that provides a common API (Application
 Programming Interface) for realtime MIDI input/output across Linux
 (native ALSA, JACK, and OSS), Macintosh OS X, SGI, and Windows
 (DirectSound and ASIO) operating systems. RtMidi significantly
 simplifies the process of interacting with computer audio hardware.
 .
 This package provides the debugging symbols.

=== debian/rules ===
#!/usr/bin/make -f

export REPACK_SH=$(CURDIR)/debian/repack.sh
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
CONFIGURE_FLAGS = --with-jack

CFLAGS += -g
ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
CFLAGS += -O0
endif

export CFLAGS

%:
	dh $@ --parallel --with autoreconf

override_dh_auto_clean:
	dh_auto_clean
	rm -rf doc/html doc/images

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_FLAGS)

override_dh_strip:
	dh_strip --dbg-package=librtmidi-dbg

get-orig-source:
	uscan --force-download

## rtmidi 2.0.1~ds0

=== debian/changelog ===
rtmidi (2.0.1~ds0-3ubuntu1) trusty; urgency=medium

  * Use autotools-dev to update config.{sub,guess} for new arches.

 -- Logan Rosen <logan@ubuntu.com>  Sun, 22 Dec 2013 17:54:37 -0500

rtmidi (2.0.1~ds0-3) unstable; urgency=low

  * Upload to unstable.

  [ Devin Anderson ]
  * debian/control, debian/rules: build rtmidi with ALSA bindings

  [ Alessio Treglia ]
  * Fix VCS url.
  * Bump Standards.

 -- Alessio Treglia <alessio@debian.org>  Wed, 08 May 2013 08:35:00 +0200

rtmidi (2.0.1~ds0-2) experimental; urgency=low

  * Add support for powerpc64 builds.
    Thanks to Hiroyuki Yamamoto for the patch. (Closes: #693592)

 -- Alessio Treglia <alessio@debian.org>  Sun, 18 Nov 2012 11:08:16 +0000

rtmidi (2.0.1~ds0-1) experimental; urgency=low

  * New upstream release.
  * Refresh 0001-buildsystem.patch

 -- Alessio Treglia <alessio@debian.org>  Thu, 02 Aug 2012 13:41:05 +0200

rtmidi (2.0.0~ds0-1) experimental; urgency=low

  * Imported Upstream version 2.0.0~ds0
  * Refresh buildsystem.
  * Pass -Xtests/midiprobe.cpp~ to dh_clean to avoid unexpected clean-up
    of upstream sources.
  * Refresh debian/copyright.
  * Bump Standards.

 -- Alessio Treglia <alessio@debian.org>  Wed, 18 Jul 2012 15:20:42 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,18 @@
 Source: rtmidi
 Section: libs
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
 Uploaders: Alessio Treglia <alessio@debian.org>
 Build-Depends:
  debhelper (>= 8.1.3~),
  dh-autoreconf,
- libjack-dev
-Standards-Version: 3.9.2
+ libjack-dev,
+ libasound2-dev,
+ autotools-dev
+Standards-Version: 3.9.4
 Homepage: http://www.music.mcgill.ca/~gary/rtmidi/
-Vcs-Git: git://git.debian.org/pkg-multimedia/rtmidi.git
+Vcs-Git: git://anonscm.debian.org/pkg-multimedia/rtmidi.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/rtmidi.git
 
 Package: librtmidi1
@@ -48,6 +51,7 @@
 Multi-Arch: same
 Depends:
  libjack-dev,
+ libasound2-dev,
  librtaudio-dev,
  librtmidi1 (= ${binary:Version}),
  ${misc:Depends},

=== debian/rules ===
#!/usr/bin/make -f

export REPACK_SH=$(CURDIR)/debian/repack.sh
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
CONFIGURE_FLAGS = --with-alsa --with-jack

CFLAGS += -g
ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
CFLAGS += -O0
endif

export CFLAGS

%:
	dh $@ --parallel --with autoreconf,autotools_dev

override_dh_clean:
	dh_clean -Xtests/midiprobe.cpp~

override_dh_auto_clean:
	dh_auto_clean
	rm -rf doc/html doc/images

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_FLAGS)

override_dh_auto_install:
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
	mkdir -p debian/tmp/usr/include
	for file in `ls librtmidi.so*`; do \
	   cp -d $$file debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/ ; \
	done
	install -m 0644 RtMidi.h debian/tmp/usr/include
	install -m 0644 rtmidi.pc \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/

override_dh_strip:
	dh_strip --dbg-package=librtmidi-dbg

get-orig-source:
	uscan --force-download

=== debian/watch ===
version=3
opts=dversionmangle=s/~ds.*// \
http://www.music.mcgill.ca/~gary/rtmidi/release/rtmidi-(.*)\.tar\.gz \
	debian sh debian/repack.stub

## rtmidi 2.1.0~ds0

=== debian/changelog ===
rtmidi (2.1.0~ds0-4) unstable; urgency=medium

  * Team upload.
  * Rename librtmidi2 for GCC 5 transition.
  * debian/control: Bump Standards-Version.
  * debian/patches/0001-buildsystem.patch: Honor LDFLAGS.

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 05 Aug 2015 01:22:07 +0200

rtmidi (2.1.0~ds0-3) unstable; urgency=low

  * Build with autotools-dev. (Closes: #751099)

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Tue, 10 Jun 2014 13:55:50 +0200

rtmidi (2.1.0~ds0-2) unstable; urgency=low

  * Upload to unstable. (Closes: #747775) (Closes: #750332) (Closes: #727498)

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Mon, 09 Jun 2014 22:36:36 +0200

rtmidi (2.1.0~ds0-1) experimental; urgency=medium

  [ Jaromír Mikeš ]
  * Added myself as uploader

  [ Alessio Treglia ]
  * New upstream release.
  * Bump SONAME.
  * Various improvements to the repackaging mechanism.
  * Bump Standards.
  * Refresh debian/copyright.
  * Refresh 0001-buildsystem.patch.
  * Fix build tests.
  * Bump Standards.

 -- Alessio Treglia <alessio@debian.org>  Sat, 03 May 2014 23:21:12 +0100

=== debian/control ===
--- 
+++ 
@@ -1,24 +1,26 @@
 Source: rtmidi
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
-Uploaders: Alessio Treglia <alessio@debian.org>
+Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
+Uploaders:
+ Alessio Treglia <alessio@debian.org>,
+ Jaromír Mikeš <mira.mikes@seznam.cz>
 Build-Depends:
- debhelper (>= 8.1.3~),
+ debhelper (>= 9~),
  dh-autoreconf,
- libjack-dev,
+ autotools-dev,
  libasound2-dev,
- autotools-dev
-Standards-Version: 3.9.4
+ libjack-dev
+Standards-Version: 3.9.6
 Homepage: http://www.music.mcgill.ca/~gary/rtmidi/
 Vcs-Git: git://anonscm.debian.org/pkg-multimedia/rtmidi.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/rtmidi.git
 
-Package: librtmidi1
+Package: librtmidi2v5
 Architecture: linux-any
 Multi-Arch: same
-Pre-Depends: ${misc:Pre-Depends}
+Pre-Depends:
+ ${misc:Pre-Depends}
 Depends:
  ${misc:Depends},
  ${shlibs:Depends}
@@ -50,10 +52,10 @@
 Architecture: linux-any
 Multi-Arch: same
 Depends:
+ libasound2-dev,
  libjack-dev,
- libasound2-dev,
  librtaudio-dev,
- librtmidi1 (= ${binary:Version}),
+ librtmidi2v5 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends}
 Description: C++ library for realtime MIDI input/ouput (development files)
@@ -71,7 +73,7 @@
 Architecture: linux-any
 Multi-Arch: same
 Depends:
- librtmidi1 (= ${binary:Version}),
+ librtmidi2v5 (= ${binary:Version}),
  ${misc:Depends}
 Description: C++ library for realtime MIDI input/ouput (debugging symbols)
  RtMidi is a set of C++ classes that provides a common API (Application

=== debian/rules ===
--- 
+++ 
@@ -13,7 +13,7 @@
 export CFLAGS
 
 %:
-	dh $@ --parallel --with autoreconf,autotools_dev
+	dh $@ --parallel --with autoreconf,autotools-dev
 
 override_dh_clean:
 	dh_clean -Xtests/midiprobe.cpp~
@@ -21,9 +21,15 @@
 override_dh_auto_clean:
 	dh_auto_clean
 	rm -rf doc/html doc/images
+	rm -rf tests/Debug/ tests/Release/
 
 override_dh_auto_configure:
 	dh_auto_configure -- $(CONFIGURE_FLAGS)
+
+override_dh_auto_test:
+	mkdir -p tests/Release
+	mkdir -p tests/Debug
+	dh_auto_test
 
 override_dh_auto_install:
 	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig

## rtmidi 2.1.1~ds0

=== debian/changelog ===
rtmidi (2.1.1~ds0-4) unstable; urgency=medium

  * Upload to unstable.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Sun, 24 Jul 2016 14:35:30 +0200

rtmidi (2.1.1~ds0-3) experimental; urgency=medium

  * Fix pkg-config-bad-directive properly.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Mon, 27 Jun 2016 18:17:22 +0200

rtmidi (2.1.1~ds0-2) experimental; urgency=medium

  * Install headers as upstream intended.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Mon, 27 Jun 2016 18:17:22 +0200

rtmidi (2.1.1~ds0-1) experimental; urgency=medium

  * Switch to get-orig-source.
  * Imported Upstream version 2.1.1~ds0
  * Bump Standards.
  * Fix VCS fields.
  * Patches refreshed/removed.
  * Add patch to not install doc images.
  * Install files by install file rather than rules file.
  * Fix some hardening.
  * Fix pkg-config-bad-directive.
  * Install upstream changelog.
  * Bump soname.
  * Install both headers.
  * Drop useless patches.
  * Add patch to pass cxxflags.
  * Remove ${shlibs:Depends} from dev package.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Fri, 17 Jun 2016 22:32:30 +0200

=== debian/control ===
--- 
+++ 
@@ -11,12 +11,12 @@
  autotools-dev,
  libasound2-dev,
  libjack-dev
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: http://www.music.mcgill.ca/~gary/rtmidi/
-Vcs-Git: git://anonscm.debian.org/pkg-multimedia/rtmidi.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/rtmidi.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/rtmidi.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/rtmidi.git
 
-Package: librtmidi2v5
+Package: librtmidi3
 Architecture: linux-any
 Multi-Arch: same
 Pre-Depends:
@@ -55,9 +55,8 @@
  libasound2-dev,
  libjack-dev,
  librtaudio-dev,
- librtmidi2v5 (= ${binary:Version}),
- ${misc:Depends},
- ${shlibs:Depends}
+ librtmidi3 (= ${binary:Version}),
+ ${misc:Depends}
 Description: C++ library for realtime MIDI input/ouput (development files)
  RtMidi is a set of C++ classes that provides a common API (Application
  Programming Interface) for realtime MIDI input/output across Linux
@@ -66,20 +65,3 @@
  simplifies the process of interacting with computer audio hardware.
  .
  This package provides the development files.
-
-Package: librtmidi-dbg
-Section: debug
-Priority: extra
-Architecture: linux-any
-Multi-Arch: same
-Depends:
- librtmidi2v5 (= ${binary:Version}),
- ${misc:Depends}
-Description: C++ library for realtime MIDI input/ouput (debugging symbols)
- RtMidi is a set of C++ classes that provides a common API (Application
- Programming Interface) for realtime MIDI input/output across Linux
- (native ALSA, JACK, and OSS), Macintosh OS X, SGI, and Windows
- (DirectSound and ASIO) operating systems. RtMidi significantly
- simplifies the process of interacting with computer audio hardware.
- .
- This package provides the debugging symbols.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow, +fortify

upstream_version ?= $(shell dpkg-parsechangelog | sed -rne 's/^Version: ([0-9.]+)(\+dfsg\d+)?.*$$/\1/p')
dfsg_version = $(upstream_version)~ds0
pkg = $(shell dpkg-parsechangelog | sed -ne 's/^Source: //p')

DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
CONFIGURE_FLAGS = --with-alsa --with-jack

CFLAGS += -g
ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
CFLAGS += -O0
endif

export CFLAGS

%:
	dh $@ --parallel --with autoreconf,autotools-dev

override_dh_clean:
	dh_clean -Xtests/midiprobe.cpp~

override_dh_auto_clean:
	dh_auto_clean
	rm -rf doc/html doc/images
	rm -rf tests/Debug/ tests/Release/

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_FLAGS)

override_dh_auto_test:
	mkdir -p tests/Release
	mkdir -p tests/Debug
	dh_auto_test

override_dh_installchangelogs:
	dh_installchangelogs doc/release.txt

# get-orig-source to drop doc and win files
get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=.
	tar -xf $(pkg)_$(upstream_version).orig.tar.gz
	mv $(pkg)-$(upstream_version) $(pkg)-$(dfsg_version)
	rm -fR $(pkg)-$(dfsg_version)/configure/
	rm -fR $(pkg)-$(dfsg_version)/._Makefile.in
	rm -fR $(pkg)-$(dfsg_version)/doc/html/
	rm -fR $(pkg)-$(dfsg_version)/doc/images/
	rm -fR $(pkg)-$(dfsg_version)/msw/
	rm -fR $(pkg)-$(dfsg_version)/tests/*.dsp
	rm -fR $(pkg)-$(dfsg_version)/tests/Debug/
	rm -fR $(pkg)-$(dfsg_version)/tests/Release/
	tar cf $(pkg)_$(dfsg_version).orig.tar $(pkg)-$(dfsg_version)
	xz -zf $(pkg)_$(dfsg_version).orig.tar
	rm -rf $(pkg)-$(dfsg_version)
	rm -rf $(pkg)_$(upstream_version).orig.tar.gz
	mv $(pkg)_$(dfsg_version).orig.tar.xz ../$(pkg)_$(dfsg_version).orig.tar.xz

=== debian/watch ===
version=3
opts=dversionmangle=s/~ds.*// \
http://www.music.mcgill.ca/~gary/rtmidi/release/rtmidi-(.*)\.tar\.gz

## rtmidi 3.0.0~ds1

=== debian/changelog ===
rtmidi (3.0.0~ds1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Fri, 27 Oct 2017 16:34:29 +0200

rtmidi (3.0.0~ds1-1~exp3) experimental; urgency=medium

  * Set hardening all.
  * Patch to enable kFreeBSD/Hurd builds.
  * Patches refreshed.
  * Drop linux-any from arch-specifier.
  * Patches renumbered.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Mon, 23 Oct 2017 01:10:22 +0200

rtmidi (3.0.0~ds1-1~exp2) experimental; urgency=medium

  * Add libjs-jquery as dep of doc package.
  * Use .links file rather than creating them manually.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Sun, 22 Oct 2017 21:37:02 +0200

rtmidi (3.0.0~ds1-1~exp1) experimental; urgency=medium

  * New upstream version 3.0.0~ds1

  [ Jaromír Mikeš ]
  * Repack by copyright file now.
    * Exclude .gitignore file on repack.
  * Add description to patch.
  * Add doc-base file.

  [ IOhannes m zmölnig ]
  * Refreshed and updated patches
    * Fixed configure.ac patch
    * Unbreak configure.ac if 'prefix' is defined
  * Soname bump: librtmidi3 -> librtmidi4
  * Added librtmidi-doc
    * Suggested by the -dev package
  * Removed .gitignore
  * Dropped unused rule in d/rules
  * Install README.md
  * Added myself to uploaders
  * Bumped standards to 4.1.1

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sun, 08 Oct 2017 23:21:26 +0200

rtmidi (2.1.1~ds0-5) unstable; urgency=medium

  * Tune .gitignore file.
  * Set compat/dh 10.
  * Sign tags.
  * Update copyright file.
  * Bump Standards.
  * Fix FTCBS (Closes: #877386).

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Tue, 03 Oct 2017 09:23:43 +0200

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
CONFIGURE_FLAGS = --with-alsa --with-jack

CFLAGS += -g
ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
CFLAGS += -O0
endif

export CFLAGS

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	rm -rf doc/html doc/images
	rm -rf tests/Debug/ tests/Release/

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_FLAGS)

override_dh_auto_install:
	rm -f doc/html/jquery.js
	dh_auto_install

override_dh_auto_test:
	mkdir -p tests/Release
	mkdir -p tests/Debug
	dh_auto_test

override_dh_installchangelogs:
	dh_installchangelogs doc/release.txt

=== debian/watch ===
# See uscan
# Compulsory line, this is a version 4 file
version=4

opts="dversionmangle=s/[~+](dfsg|repack|ds)([.]?[0-9]*)?$//,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rtmidi-$1.tar.gz%" \
   https://github.com/thestk/rtmidi/tags \
   (?:.*?/)?v(\d[\d.]*)\.tar\.gz debian uupdate

## rtmidi 4.0.0

=== debian/changelog ===
rtmidi (4.0.0-1) unstable; urgency=medium

  * Upload to unstable.

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Install lib*.a files in -dev package
  * Remove unused variables from d/rules
  * Bump dh-compat to 13

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 27 Oct 2020 22:34:00 +0100

rtmidi (4.0.0-1~exp1) experimental; urgency=medium

  * New upstream version 4.0.0

  [ Jaromír Mikeš ]
  * Patch forwarded.

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/control: Set Vcs-* to salsa.debian.org
  * Use debhelper-compat instead of debian/compat

  [ Felipe Sateler ]
  * Change maintainer address to debian-multimedia@lists.debian.org

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Refresh patches
    * Drop patches applied upstream
  * Rename binary package to "librtmidi5" to reflect soname bump
  * Only depend on libasound2-dev on linux-any
  * Update d/copyright
    * Add 'licensecheck' target
    * Generate initial d/copyright_hints
  * Add salsa-ci configuration
  * Declare that building this package does not require 'root' powers.
  * Update d/watch
  * Bump dh-compat to 12
  * Bump standards version to 4.5.0

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 13 Apr 2020 23:49:53 +0200

=== debian/control ===
--- 
+++ 
@@ -1,29 +1,31 @@
 Source: rtmidi
 Section: libs
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Alessio Treglia <alessio@debian.org>,
- Jaromír Mikeš <mira.mikes@seznam.cz>
+ Jaromír Mikeš <mira.mikes@seznam.cz>,
+ IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
 Build-Depends:
- debhelper (>= 9~),
- dh-autoreconf,
- autotools-dev,
- libasound2-dev,
- libjack-dev
-Standards-Version: 3.9.8
-Homepage: http://www.music.mcgill.ca/~gary/rtmidi/
-Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/rtmidi.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/rtmidi.git
+ debhelper-compat (= 13),
+ libasound2-dev [linux-any],
+ libjack-dev,
+Build-Depends-Indep:
+ doxygen,
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
+Homepage: https://www.music.mcgill.ca/~gary/rtmidi/
+Vcs-Git: https://salsa.debian.org/multimedia-team/rtmidi.git
+Vcs-Browser: https://salsa.debian.org/multimedia-team/rtmidi
 
-Package: librtmidi3
-Architecture: linux-any
+Package: librtmidi5
+Architecture: any
 Multi-Arch: same
 Pre-Depends:
  ${misc:Pre-Depends}
 Depends:
  ${misc:Depends},
- ${shlibs:Depends}
+ ${shlibs:Depends},
 Description: C++ library for realtime MIDI input/ouput
  RtMidi is a set of C++ classes that provides a common API (Application
  Programming Interface) for realtime MIDI input/output across Linux
@@ -49,14 +51,15 @@
 
 Package: librtmidi-dev
 Section: libdevel
-Architecture: linux-any
+Architecture: any
 Multi-Arch: same
 Depends:
- libasound2-dev,
+ libasound2-dev [linux-any],
  libjack-dev,
  librtaudio-dev,
- librtmidi3 (= ${binary:Version}),
- ${misc:Depends}
+ librtmidi5 (= ${binary:Version}),
+ ${misc:Depends},
+Suggests: librtmidi-doc
 Description: C++ library for realtime MIDI input/ouput (development files)
  RtMidi is a set of C++ classes that provides a common API (Application
  Programming Interface) for realtime MIDI input/output across Linux
@@ -65,3 +68,19 @@
  simplifies the process of interacting with computer audio hardware.
  .
  This package provides the development files.
+
+Package: librtmidi-doc
+Architecture: all
+Section: doc
+Multi-Arch: foreign
+Depends:
+ ${misc:Depends},
+ libjs-jquery,
+Description: C++ library for realtime MIDI input/ouput (documentation files)
+ RtMidi is a set of C++ classes that provides a common API (Application
+ Programming Interface) for realtime MIDI input/output across Linux
+ (native ALSA, JACK, and OSS), Macintosh OS X, SGI, and Windows
+ (DirectSound and ASIO) operating systems. RtMidi significantly
+ simplifies the process of interacting with computer audio hardware.
+ .
+ This package provides the API documentation.

=== debian/rules ===
--- 
+++ 
@@ -3,8 +3,6 @@
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
-DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
-DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 CONFIGURE_FLAGS = --with-alsa --with-jack
 
 CFLAGS += -g
@@ -36,3 +34,9 @@
 
 override_dh_installchangelogs:
 	dh_installchangelogs doc/release.txt
+
+licensecheck:
+	licensecheck --deb-machine -r * \
+		> debian/copyright_newhints
+	cmp debian/copyright_hints debian/copyright_newhints \
+		&& rm debian/copyright_newhints

## rtmidi 5.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,12 @@
 cmake_minimum_required(VERSION 3.10 FATAL_ERROR)
 
 # Define a C++ project.
-project(RtMidi LANGUAGES CXX)
+project(RtMidi LANGUAGES CXX C)
+
+# standards version
+set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
+set(CMAKE_CXX_EXTENSIONS OFF)
 
 # Check for Jack (any OS)
 find_library(JACK_LIB jack)
@@ -76,8 +81,10 @@
 # Init variables
 set(rtmidi_SOURCES RtMidi.cpp RtMidi.h rtmidi_c.cpp rtmidi_c.h)
 set(LINKLIBS)
+set(PUBLICLINKLIBS)
 set(INCDIRS)
 set(PKGCONFIG_REQUIRES)
+set(LIBS_REQUIRES)
 set(API_DEFS)
 set(API_LIST)
 
@@ -106,7 +113,7 @@
   check_symbol_exists(jack_port_rename ${jack_INCLUDEDIR}/jack/jack.h JACK_HAS_PORT_RENAME)
   set(CMAKE_REQUIRED_LIBRARIES ${tmp_CMAKE_REQUIRED_LIBRARIES})
   if(JACK_HAS_PORT_RENAME)
-    list(APPEND API_DEFS "JACK_HAS_PORT_RENAME")
+    list(APPEND API_DEFS "-DJACK_HAS_PORT_RENAME")
   endif()
 endif()
 
@@ -133,12 +140,14 @@
 
 # CoreMIDI
 if(RTMIDI_API_CORE)
+  find_library(CORESERVICES_LIB CoreServices)
+  find_library(COREAUDIO_LIB CoreAudio)
+  find_library(COREMIDI_LIB CoreMIDI)
+  find_library(COREFOUNDATION_LIB CoreFoundation)
   list(APPEND API_DEFS "-D__MACOSX_CORE__")
   list(APPEND API_LIST "coremidi")
-  list(APPEND LINKLIBS "-framework CoreServices")
-  list(APPEND LINKLIBS "-framework CoreAudio")
-  list(APPEND LINKLIBS "-framework CoreMIDI")
-  list(APPEND LINKLIBS "-framework CoreFoundation")
+  list(APPEND LINKLIBS ${CORESERVICES_LIB} ${COREAUDIO_LIB} ${COREMIDI_LIB} ${COREFOUNDATION_LIB})
+  list(APPEND LIBS_REQUIRES "-framework CoreServices -framework CoreAudio -framework CoreMIDI -framework CoreFoundation")
   list(APPEND LINKFLAGS "-Wl,-F/Library/Frameworks")
 endif()
 
@@ -147,11 +156,10 @@
   find_package(Threads REQUIRED
     CMAKE_THREAD_PREFER_PTHREAD
     THREADS_PREFER_PTHREAD_FLAG)
-  list(APPEND LINKLIBS Threads::Threads)
+  list(APPEND PUBLICLINKLIBS Threads::Threads)
 endif()
 
 # Create library targets.
-cmake_policy(SET CMP0042 OLD)
 set(LIB_TARGETS)
 
 # Use RTMIDI_BUILD_SHARED_LIBS / RTMIDI_BUILD_STATIC_LIBS if they
@@ -174,30 +182,33 @@
 list(APPEND LIB_TARGETS rtmidi)
 
 # Add headers destination for install rule.
-set_target_properties(rtmidi PROPERTIES PUBLIC_HEADER RtMidi.h
+set_property(TARGET rtmidi PROPERTY PUBLIC_HEADER RtMidi.h rtmidi_c.h)
+set_target_properties(rtmidi PROPERTIES
   SOVERSION ${SO_VER}
   VERSION ${FULL_VER})
 
 # Set include paths, populate target interface.
-target_include_directories(rtmidi PRIVATE
-  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
-  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
-  ${INCDIRS})
+target_include_directories(rtmidi PRIVATE ${INCDIRS}
+                                  PUBLIC
+                                    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
+                                    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
 
 # Set compile-time definitions
 target_compile_definitions(rtmidi PRIVATE ${API_DEFS})
 target_compile_definitions(rtmidi PRIVATE RTMIDI_EXPORT)
-target_link_libraries(rtmidi ${LINKLIBS})
+target_link_libraries(rtmidi PUBLIC ${PUBLICLINKLIBS} 
+                             PRIVATE ${LINKLIBS})
 
 # Set standard installation directories.
 include(GNUInstallDirs)
 
 # Add tests if requested.
-include(CTest)
+option(RTMIDI_BUILD_TESTING "Build test programs" ON)
 if (NOT DEFINED RTMIDI_BUILD_TESTING OR RTMIDI_BUILD_TESTING STREQUAL "")
   set(RTMIDI_BUILD_TESTING ${BUILD_TESTING})
 endif()
 if (RTMIDI_BUILD_TESTING)
+  include(CTest)
   add_executable(cmidiin    tests/cmidiin.cpp)
   add_executable(midiclock  tests/midiclock.cpp)
   add_executable(midiout    tests/midiout.cpp)
@@ -205,8 +216,9 @@
   add_executable(qmidiin    tests/qmidiin.cpp)
   add_executable(sysextest  tests/sysextest.cpp)
   add_executable(apinames   tests/apinames.cpp)
+  add_executable(testcapi   tests/testcapi.c)
   list(GET LIB_TARGETS 0 LIBRTMIDI)
-  set_target_properties(cmidiin midiclock midiout midiprobe qmidiin sysextest apinames
+  set_target_properties(cmidiin midiclock midiout midiprobe qmidiin sysextest apinames testcapi
     PROPERTIES RUNTIME_OUTPUT_DIRECTORY tests
                INCLUDE_DIRECTORIES ${CMAKE_CURRENT_SOURCE_DIR}
                LINK_LIBRARIES ${LIBRTMIDI})
@@ -222,7 +234,9 @@
 
 # PkgConfig file
 string(REPLACE ";" " " req "${PKGCONFIG_REQUIRES}")
+string(REPLACE ";" " " req_libs "${LIBS_REQUIRES}")
 string(REPLACE ";" " " api "${API_DEFS}")
+set(prefix ${CMAKE_INSTALL_PREFIX})
 configure_file("${CMAKE_CURRENT_SOURCE_DIR}/rtmidi.pc.in" "rtmidi.pc" @ONLY)
 
 # Add install rule.
@@ -231,24 +245,13 @@
         LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
         ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
         RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
-        PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
+        PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/rtmidi)
 
 # Store the package in the user registry.
 export(PACKAGE RtMidi)
 
 # Set installation path for CMake files.
 set(RTMIDI_CMAKE_DESTINATION share/rtmidi)
-
-# Create CMake configuration export file.
-if(NEED_PTHREAD)
-  file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/RtMidiConfig.cmake "find_package(Threads REQUIRED)\n")
-endif()
-
-file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/RtMidiConfig.cmake "include(\${CMAKE_CURRENT_LIST_DIR}/RtMidiTargets.cmake)")
-
-# Install CMake configuration export file.
-install(FILES ${CMAKE_BINARY_DIR}/RtMidiConfig.cmake
-        DESTINATION ${RTMIDI_CMAKE_DESTINATION})
 
 # Export library target (build-tree).
 export(EXPORT RtMidiTargets
@@ -271,3 +274,29 @@
 install(
     FILES ${CMAKE_CURRENT_BINARY_DIR}/rtmidi.pc
     DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
+
+# Set up CMake package
+include(CMakePackageConfigHelpers)
+
+# Write cmake package version file
+write_basic_package_version_file(
+    RtMidi-config-version.cmake
+    VERSION ${FULL_VER}
+    COMPATIBILITY SameMajorVersion
+)
+
+# Write cmake package config file
+configure_package_config_file (
+    cmake/RtMidi-config.cmake.in
+    RtMidi-config.cmake
+    INSTALL_DESTINATION "${RTMIDI_CMAKE_DESTINATION}"
+)
+
+# Install package files
+install (
+    FILES
+        "${CMAKE_CURRENT_BINARY_DIR}/RtMidi-config.cmake"
+        "${CMAKE_CURRENT_BINARY_DIR}/RtMidi-config-version.cmake"
+    DESTINATION
+        "${RTMIDI_CMAKE_DESTINATION}"
+)

=== debian/changelog ===
rtmidi (5.0.0-3build3) noble; urgency=medium

  * No-change rebuild against libasound2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 07 Apr 2024 07:22:54 +0000

rtmidi (5.0.0-3build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 07:09:17 +0000

rtmidi (5.0.0-3build1) noble; urgency=medium

  * No-change rebuild against libasound2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 07:02:23 +0000

rtmidi (5.0.0-3) unstable; urgency=medium

  [ Dennis Braun ]
  * Add libjack-jackd2-dev to B-D and librtmidi-dev Depends
  * Bump Standards Version to 4.6.1

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Apply 'wrap-and-sort -ast'

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 28 Sep 2022 18:45:41 +0200

rtmidi (5.0.0-2) unstable; urgency=medium

  * Skip ALSA-support on non-linux

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 30 Nov 2021 17:16:56 +0100

rtmidi (5.0.0-1) unstable; urgency=medium

  * Upload to unstable.
  * Note that RtMidi-5 requires C++11

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 30 Nov 2021 13:46:29 +0100

rtmidi (5.0.0-1~exp1) experimental; urgency=medium

  * New upstream version 5.0.0
    * Refresh patches
  * Rename binary package to "librtmidi6" to reflect soname bump
  * Drop old-style CFLAGS override
  * Use execute_{before,after}_dh_... instead of override_dh_...
  * Update d/copyright
    * Regenerate d/copyright_hints
  * Bump standards version to 4.6.0

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 24 Nov 2021 17:09:50 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: rtmidi
 Section: libs
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Alessio Treglia <alessio@debian.org>,
  Jaromír Mikeš <mira.mikes@seznam.cz>,
@@ -9,20 +10,20 @@
 Build-Depends:
  debhelper-compat (= 13),
  libasound2-dev [linux-any],
- libjack-dev,
+ libjack-dev | libjack-jackd2-dev,
 Build-Depends-Indep:
  doxygen,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: https://www.music.mcgill.ca/~gary/rtmidi/
 Vcs-Git: https://salsa.debian.org/multimedia-team/rtmidi.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/rtmidi
 
-Package: librtmidi5
+Package: librtmidi6
 Architecture: any
 Multi-Arch: same
 Pre-Depends:
- ${misc:Pre-Depends}
+ ${misc:Pre-Depends},
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
@@ -55,11 +56,12 @@
 Multi-Arch: same
 Depends:
  libasound2-dev [linux-any],
- libjack-dev,
+ libjack-dev | libjack-jackd2-dev,
  librtaudio-dev,
- librtmidi5 (= ${binary:Version}),
+ librtmidi6 (= ${binary:Version}),
  ${misc:Depends},
-Suggests: librtmidi-doc
+Suggests:
+ librtmidi-doc,
 Description: C++ library for realtime MIDI input/ouput (development files)
  RtMidi is a set of C++ classes that provides a common API (Application
  Programming Interface) for realtime MIDI input/output across Linux
@@ -74,8 +76,8 @@
 Section: doc
 Multi-Arch: foreign
 Depends:
+ libjs-jquery,
  ${misc:Depends},
- libjs-jquery,
 Description: C++ library for realtime MIDI input/ouput (documentation files)
  RtMidi is a set of C++ classes that provides a common API (Application
  Programming Interface) for realtime MIDI input/output across Linux

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CONFIGURE_FLAGS = --with-jack

ifeq ($(DEB_HOST_ARCH_OS),linux)
CONFIGURE_FLAGS += --with-alsa
endif


%:
	dh $@

execute_after_dh_auto_clean:
	rm -rf doc/html doc/images
	rm -rf tests/Debug/ tests/Release/

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_FLAGS)

execute_before_dh_auto_install:
	rm -f doc/html/jquery.js

execute_before_dh_auto_test:
	mkdir -p tests/Release
	mkdir -p tests/Debug

override_dh_installchangelogs:
	dh_installchangelogs doc/release.txt

licensecheck:
	licensecheck --deb-machine -r * \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints

## rtmidi 6.0.0

=== android/app/src/main/cpp/CMakeLists.txt ===
# For more information about using CMake with Android Studio, read the
# documentation: https://d.android.com/studio/projects/add-native-code.html

# Sets the minimum version of CMake required to build the native library.

cmake_minimum_required(VERSION 3.22.1)

# Declares and names the project.

project("midireader")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__AMIDI__")

# Creates and names a library, sets it as either STATIC
# or SHARED, and provides the relative paths to its source code.
# You can define multiple libraries, and CMake builds them for you.
# Gradle automatically packages shared libraries with your APK.

add_library( # Sets the name of the library.
        midireader

        # Sets the library as a shared library.
        SHARED

        # Provides a relative path to your source file(s).
        RtMidi.cpp app-jni.cpp)

# Searches for a specified prebuilt library and stores the path as a
# variable. Because CMake includes system libraries in the search path by
# default, you only need to specify the name of the public NDK library
# you want to add. CMake verifies that the library exists before
# completing its build.

find_library( # Sets the name of the path variable.
        log-lib

        # Specifies the name of the NDK library that
        # you want CMake to locate.
        log)

# Specifies libraries CMake should link to your target library. You
# can link multiple libraries, such as libraries you define in this
# build script, prebuilt third-party libraries, or system libraries.

target_link_libraries( # Specifies the target library.
        midireader

        # Links the target library to the log library
        # included in the NDK.
        ${log-lib} amidi nativehelper)

=== debian/changelog ===
rtmidi (6.0.0-2) unstable; urgency=medium

  * Upload to unstable.
  * Bump standards version to 4.7.0

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 07 Jun 2024 15:02:39 +0200

rtmidi (6.0.0-1~exp1) experimental; urgency=medium

  * New upstream version 6.0.0
    + Refresh patches
  * Rename binary package to "librtmidi7" to reflect soname bump
  * Update copyright information
    + Update d/copyright
    + Re-generate d/copyright_hints
    + Modernize 'licensecheck' target
  * Bump standards version to 4.6.2

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 08 Aug 2023 21:35:44 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: rtmidi
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Alessio Treglia <alessio@debian.org>,
  Jaromír Mikeš <mira.mikes@seznam.cz>,
@@ -13,13 +12,13 @@
  libjack-dev | libjack-jackd2-dev,
 Build-Depends-Indep:
  doxygen,
-Standards-Version: 4.6.1
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://www.music.mcgill.ca/~gary/rtmidi/
 Vcs-Git: https://salsa.debian.org/multimedia-team/rtmidi.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/rtmidi
 
-Package: librtmidi6
+Package: librtmidi7
 Architecture: any
 Multi-Arch: same
 Pre-Depends:
@@ -58,7 +57,7 @@
  libasound2-dev [linux-any],
  libjack-dev | libjack-jackd2-dev,
  librtaudio-dev,
- librtmidi6 (= ${binary:Version}),
+ librtmidi7 (= ${binary:Version}),
  ${misc:Depends},
 Suggests:
  librtmidi-doc,

=== debian/rules ===
--- 
+++ 
@@ -30,8 +30,14 @@
 override_dh_installchangelogs:
 	dh_installchangelogs doc/release.txt
 
+DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
+        debian/.*|android/images/midi.png
+# licensecheck v1
+.PHONY: licensecheck
 licensecheck:
-	licensecheck --deb-machine -r * \
+	LANG=C.UTF-8 licensecheck \
+		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
+		--check '.*' --recursive --deb-machine --lines 0 * \
 		> debian/copyright_newhints
 	cmp debian/copyright_hints debian/copyright_newhints \
 		&& rm debian/copyright_newhints
